#!/usr/local/bin/perl -w
use strict;
use CGI qw(:standard);

my $results = 'survey_results.txt';
my %data = ();
my $thing = '';
my $val = 0;

open(RESULTS, $results) or die "Can't open results file: $!";
while (<RESULTS>) {
    ($thing, $val) = split(' ');
    $data{$thing} = $val;
}
close(RESULTS);

# overall total
$data{total}++;
# handle age
if (!param('age')) { $data{age_na}++ }
else {
    if (param('age') eq 'under18') { $data{age_under18}++; }
    elsif (param('age') eq '18to34') { $data{age_18to34}++; }
    elsif (param('age') eq '35to50') { $data{age_35to50}++; }
    elsif (param('age') eq '50plus') { $data{age_50plus}++; }
}

# handle sex
if (!param('sex')) { $data{sex_na}++ }
else {
    if (param('sex') eq 'male') { $data{sex_m}++; }
    elsif (param('sex') eq 'female') { $data{sex_f}++; }
}

# perl
if (!param('perl')) { $data{perl_na}++ }
else {
    if (param('perl') eq 'yes') { $data{perl_y}++; }
    elsif (param('perl') eq 'no') { $data{perl_n}++; }
}

open(RESULTS, ">$results") or die "Can't write to results file: $!";
foreach $thing (keys %data) {
    print RESULTS "$thing $data{$thing}\n";
}
close(RESULTS);

print header;
print start_html('Thank you');
print <<EOF;
<h1>Thank you for filling out our survey!</h1>
<p>Our results so far:
<p>Sex:
<table border="1"><tr><th>Male</th><td>
EOF

print &percent('sex_m'), "</td></tr>\n";
print "<tr><th>Female</th><td>\n";
print &percent('sex_f'), "</td></tr>\n";
print "<tr><th>No Answer</th><td>\n";
print &percent('sex_na'), "</td></tr>\n";
print "</table>\n";

print "<p>Age:\n";
print "<table border=\"1\"><tr><th>Under 18</th><td>\n";
print &percent('age_under18'), "</td></tr>\n";
print "<tr><th>18 to 34</th><td>\n";
print &percent('age_18to34'), "</td></tr>\n";
print "<tr><th>35 to 50</th><td>\n";
print &percent('age_35to50'), "</td></tr>\n";
print "<tr><th>Over 50</th><td>\n";
print &percent('age_50plus'), "</td></tr>\n";
print "<tr><th>No Answer</th><td>\n";
print &percent('age_na'), "</td></tr>\n";
print "</table>\n";
print "<p>Perl Programmer?\n";
print "<table border=\"1\"><tr><th>Yes</th><td>\n";
print &percent('perl_y'), "</td></tr>\n";
print "<tr><th>No</th><td>\n";
print &percent('perl_n'), "</td></tr>\n";
print "<tr><th>No Answer</th><td>\n";
print &percent('perl_na'), "</td></tr>\n";
print "</table>\n";

print end_html;

sub percent {
    if (defined $data{$_[0]}) {
        return sprintf("%.1f%%", $data{$_[0]} / $data{total} * 100);
    }
    else { return '0%'; }
}

