#!/usr/local/bin/perl -w
use strict;
use Cwd;

open(OUT, ">index.html") or die "Can't open index file: $!\n";
&printhead();
&processfiles();
&printtail();

sub printhead {
    my $curr = cwd();
    print OUT "<html>\n<head>\n";
    print OUT "<title>Image files in directory $curr</title>\n";
    print OUT "</head>\n<body>\n";
    print OUT "<h1>Image Files</h1>\n";
    print OUT "<p>";
}

sub processfiles {
    opendir(CURRDIR, '.') or die "Can't open directory ($!), exiting.\n";
    my $file = "";

    while (defined($file = readdir(CURRDIR))) {
        if (-f $file and $file =~ /(\.gif|\.jpe?g)$/) {
            print OUT  "<a href=\"$file\">$file</a><br />\n";
        }
    }
    closedir(CURRDIR)
}

sub printtail {
    print OUT "</p></body></html>\n";
    close(OUT);
}

