#!/usr/local/bin/perl -w
use strict;

my $artdb = "artists.txt";              # name of artists database
my %artists = ();                       # hash of artists, keyed by last name

&read_input();
&process();

sub read_input {
    my $in = '';                # temp input line
    my ($fn,$ln,$bd,$dd);       # last name, first name
                                # date of birth, date of death
    my %artist = ();            # temp artist hash

    open(FILE, $artdb) or die "Cannot open artist's database ($artdb): $!\n";

    while () {
        # name and dates on first line
        chomp($in = <FILE>);
        if ($in) {
            ($ln,$fn,$bd,$dd) = split(',',$in);
            $artist{FN} = $fn;
            $artist{BD} = $bd;
            $artist{DD} = $dd;

            chomp($in = <FILE>); # list of works in second line
            if ($in) {
                my @works = split(':',$in);
                $artist{works} = \@works;
            } else { print "no works";}

            # add a reference to the artist hash in the bigger
            # artists hash
            $artists{$ln} = { %artist };

        } else { last; }        # end of DB
    }

}

sub process {
    my $input = '';
    my $matched = 0;

    print "Enter an Artist's Name: ";
    chomp($input = <>);

    foreach (keys %artists) {
        if (/$input/i  and !$matched) {
            $matched = 1;
            my $ref = $artists{$_};
            print "$_, $ref->{FN} $ref->{BD}-$ref->{DD}\n";
            my $work = '';
            foreach $work (@{$ref->{works}}) {
                print "   $work\n";
            }
        }
    }
    if (!$matched) {
        print "Artist $input not found.\n";
    }
}
